<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import {
  NextStep,
  ReportCta,
  SideNavigationVariant,
} from '../../components/common/index.vue';
import { CtaBlock, SolutionsCards } from '../../components/solutions/index.vue';
import {
  OverviewCards,
  StatsTimeline,
} from '../../components/dedicated/index.vue';
import { EducationCaseStudyCarousel } from '../../components/solutions/education/index.vue';
import { BySolutionBenefits } from '../../components/solutions/by-solution/index.vue';
import { SolutionsHero } from '~/components/solutions/index.vue';

export default Vue.extend({
  components: {
    NextStep,
    SolutionsHero,
    ReportCta,
    BySolutionBenefits,
    SolutionsCards,
    OverviewCards,
    CtaBlock,
    EducationCaseStudyCarousel,
    SideNavigationVariant,
    StatsTimeline,
  },
  async asyncData({ $dedicatedService }) {
    try {
      const doc = await $dedicatedService.getContent(`dedicated`, true);
      return { doc };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).doc,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div class="dedicated-wrapper">
    <SlpContainer>
      <component
        :is="component.name"
        v-for="component in doc.components"
        :key="component.name"
        :data="component.data"
        v-bind="component"
        :variant="component.data?.variant ? component.data?.variant : null"
      >
        <slot v-if="component.slot_enabled">
          <component
            :is="subcomponent.name"
            v-for="(subcomponent, item) in component.slot_content"
            :key="item"
            v-bind="subcomponent"
          >
            <slot v-if="subcomponent.slot_enabled">
              <component
                :is="contents.name"
                v-for="(contents, subitem) in subcomponent.slot_content"
                :key="subitem"
                v-bind="contents"
              />
            </slot>
          </component>
        </slot>
      </component>
    </SlpContainer>
  </div>
</template>
<style scoped lang="scss">
.dedicated-wrapper {
  overflow: hidden;
}

div[role='main'] {
  overflow: clip;
}
</style>
